import * as d3 from 'd3';
import { viz } from './viz';

export const main = (container, { state, setState }) => {
  if (state.width === undefined) {
    const resizeObserver = new ResizeObserver((entries) => {
      const { width, height } = entries[0].contentRect;
      setState((prev) => ({ ...prev, width, height }));
    });
    resizeObserver.observe(container);
    return;
  }

  const { width, height } = state;

  const svg = d3
    .select(container)
    .selectAll('svg')
    .data([null])
    .join('svg')
    .attr('width', width)
    .attr('height', height);

  svg.call(viz, {
    innerRectFill: '#B5B5B5',
    marginTop: 50,
    marginBottom: 50,
    marginLeft: 50,
    marginRight: 50,
    width,
    height,
  });
};
